# Dee Dee Games Profit Management System
# Author: Selina Dennis, 2011
# Modified by: <YOUR NAME GOES HERE>

from Tkinter import *
from datetime import *

class deePMS(Frame):

    # Initialize the entire frame
    def __init__(self, master=None):
        Frame.__init__(self, master)
        self.grid()
        self.fnCreateWidgets()
        
    # Create the widgets that will appear on the frame
    def fnCreateWidgets(self):
        # Initialize Variables
        self.strDayStart = StringVar()
        self.strDayStart.set("-DD-")
        self.strMonStart = StringVar()
        self.strMonStart.set("-MM-")
        self.strYearStart = StringVar()
        self.strYearStart.set("-YYYY-")

        self.strDayEnd = StringVar()
        self.strDayEnd.set("-DD-")
        self.strMonEnd = StringVar()
        self.strMonEnd.set("-MM-")
        self.strYearEnd = StringVar()
        self.strYearEnd.set("-YYYY-")

        self.flProgProfitTotal = StringVar()
        self.flProgProfitTotal.set("0.00")

        # Pre-set values
        self.arrMonths = []
        for i in range(1, 13):
            self.arrMonths.append( "%02d" % i )
        
        self.arrDays = []
        for i in range(1, 32):
            self.arrDays.append( "%02d" % i)
        
        self.arrYears = []
        # Dates should start from January 1st, 2011
        for i in range( 2011, datetime.now().year+1 ):
            self.arrYears.append( i )

        # Place an image across the top
        imgDefaultImage = PhotoImage(file='deePMS.gif')
        self.lblImage = Label(self, image=imgDefaultImage)
        self.lblImage.photo = imgDefaultImage
        self.lblImage.grid(column=0, row=0, columnspan=9)

        self.lblProfLoss = Label(self,
                                 text="Profit Statement",
                                 font=("Calibri", 12, "bold"),
                                 anchor="w")
        self.lblProfLoss.grid(column=0, row=1, sticky=W,
                              columnspan=6)

        self.lblDateStart = Label(self, text="Start Date",
                                  font=("Calibri", 12),
                                  anchor="w")
        self.lblDateStart.grid(column=0, row=2, sticky=W,
                               columnspan=3)

        self.omDayStart = OptionMenu(self, self.strDayStart,
                                     *(self.arrDays))
        self.omDayStart.config(width=4)
        self.omDayStart.grid(column=4, row=2, sticky=EW)

        self.omMonStart = OptionMenu(self, self.strMonStart,
                                     *(self.arrMonths))
        self.omMonStart.config(width=4)
        self.omMonStart.grid(column=5, row=2, sticky=EW)

        self.omYearStart = OptionMenu(self,
                                      self.strYearStart,
                                      *(self.arrYears))
        self.omYearStart.config(width=4)
        self.omYearStart.grid(column=6, row=2, sticky=EW)

        self.lblDateEnd = Label(self, text="End Date",
                                font=("Calibri", 12),
                                anchor="w")
        self.lblDateEnd.grid(column=0, row=3, sticky=W,
                             columnspan=3)

        self.omDayEnd = OptionMenu(self, self.strDayEnd,
                                   *(self.arrDays))
        self.omDayEnd.config(width=4)
        self.omDayEnd.grid(column=4, row=3, sticky=EW)

        self.omMonEnd = OptionMenu(self, self.strMonEnd,
                                   *(self.arrMonths))
        self.omMonEnd.config(width=4)
        self.omMonEnd.grid(column=5, row=3, sticky=EW)

        self.omYearEnd = OptionMenu(self, self.strYearEnd,
                                    *(self.arrYears))
        self.omYearEnd.config(width=4)
        self.omYearEnd.grid(column=6, row=3, sticky=EW)
        
        self.btnReset = Button(self, text="Reset",
                                font=("Calibri", 12),
                                command = self.fnReset)
        self.btnReset.grid(column=0, row=10, sticky=W,
                            columnspan=3)
                
        self.btnSubmit = Button(self, text="Create Report",
                                font=("Calibri", 12),
                                command = self.fnCreateProfitLoss)
        self.btnSubmit.grid(column=4, row=10, sticky=E,
                            columnspan=3)

        self.lblProgProfit = Label(self, text="Programmer Payment:",
                                   font=("Calibri", 12),
                                   anchor="w")
        self.lblProgProfit.grid(column=0, row=11, sticky=W,
                                columnspan=3)

        self.lblProgProfitTtl = Label(self, textvariable=self.flProgProfitTotal,
                                   font=("Calibri", 12),
                                   anchor="w")
        self.lblProgProfitTtl.grid(column=4, row=11, sticky=W,
                                columnspan=3)
        
    # Reset all values in the form
    def fnReset(self):
        self.strDayStart.set("-DD-")
        self.strMonStart.set("-MM-")
        self.strYearStart.set("-YYYY-")

        self.strDayEnd.set("-DD-")
        self.strMonEnd.set("-MM-")
        self.strYearEnd.set("-YYYY-")

        self.flProgProfitTotal.set("0.00")

### CODE BELOW HERE IS INCOMPLETE ###      
    def fnCreateProfitLoss(self):
        flTotalProfit = 0
        flTotalProgrammerSalary = 0

        ## Get the date information from the GUI
        intStartDay = int(self.strDayStart.get())
        intStartMon = int(self.strMonStart.get())
        intStartYear = int(self.strYearStart.get())

        intEndDay = int(self.strDayEnd.get())
        intEndMon = int(self.strMonEnd.get())
        intEndYear = int(self.strYearEnd.get())

        ## Denise, I quit! You don't pay me enough
        ## and donuts will only get you so far!
        ## INSERT CODE HERE ##
### CODE ABOVE HERE IS INCOMPLETE ###
        self.flProgProfitTotal.set( "%0.2f" % flTotalProgrammerSalary)
        
## CREATE THE APPLICATION ##
app = deePMS()
app.master.title("I Can Haz PMS")
app.master.minsize(320,320)
app.mainloop()
